# coding: utf-8

"""
    VMware Aria Automation Assembler IaaS API

    IAAS API is a RESTful service, which allows users to execute provisioning related UI actions via an API.  This page describes the RESTful APIs for IAAS API. The APIs facilitate CRUD operations on the various resources and entities used throughout VMware Aria Automation Assembler(Cloud Accounts, Cloud zones, Computes, Mappings, etc.) and allows operations on them (creating a cloud account, patching a machine, creating image progile, etc.).  The APIs that list collections of resources also support OData like implementation. Below query params can be used across different IAAS API endpoints  Example: 1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.     ```/iaas/api/cloud-accounts?$orderby=name%20desc```  2. `$top` -  number of records you want to get.     ```/iaas/api/cloud-accounts?$top=20```  3. `$skip` -  number of records you want to skip.      ```/iaas/api/cloud-accounts?$skip=10```  4. `$select` - select a subset of properties to include in the response.        ```/project-service/api/projects?$top=10&$skip=2```  5. `$filter` -  filter the results by a specified predicate expression. Operators: eq, ne, and, or.\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'ABC*'``` - name starts with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC*'``` - name contains 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20eq%20'*ABC'``` - name ends with 'ABC'\\     /iaas/api/projects and /iaas/api/deployments support different format for partial match:\\     ```/iaas/api/projects?$filter=startswith(name, 'ABC')``` - name starts with 'ABC'\\     ```/iaas/api/projects?$filter=substringof('ABC', name``` - name contains 'ABC'\\     ```/iaas/api/projects?$filter=endswith(name, 'ABC')``` - name ends with 'ABC'\\     ```/iaas/api/cloud-accounts?$filter=name%20ne%20'example-cloud-account'%20or%20customProperties.isExternal%20eq%20'false'```  6. `$count` -  flag which when specified, regardless of the assigned value, shows the total number of records. If the collection has a filter it shows the number of records matching the filter.\\     ```/iaas/api/cloud-accounts?$count=true```   # noqa: E501

    OpenAPI spec version: 2021-07-15
    Contact: sales@vmware.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class LoadBalancer(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'created_at': 'str',
        'updated_at': 'str',
        'owner': 'str',
        'owner_type': 'str',
        'org_id': 'str',
        'links': 'object',
        'name': 'str',
        'description': 'str',
        'external_id': 'str',
        'project_id': 'str',
        'external_zone_id': 'str',
        'external_region_id': 'str',
        'cloud_account_ids': 'list[str]',
        'deployment_id': 'str',
        'provisioning_status': 'str',
        'tags': 'list[IaasapistorageprofilesidTags]',
        'custom_properties': 'dict(str, str)',
        'address': 'str',
        'type': 'str',
        'logging_level': 'str',
        'routes': 'list[IaasapiloadbalancersidoperationsscaleRoutes]'
    }

    attribute_map = {
        'id': 'id',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt',
        'owner': 'owner',
        'owner_type': 'ownerType',
        'org_id': 'orgId',
        'links': '_links',
        'name': 'name',
        'description': 'description',
        'external_id': 'externalId',
        'project_id': 'projectId',
        'external_zone_id': 'externalZoneId',
        'external_region_id': 'externalRegionId',
        'cloud_account_ids': 'cloudAccountIds',
        'deployment_id': 'deploymentId',
        'provisioning_status': 'provisioningStatus',
        'tags': 'tags',
        'custom_properties': 'customProperties',
        'address': 'address',
        'type': 'type',
        'logging_level': 'loggingLevel',
        'routes': 'routes'
    }

    def __init__(self, id=None, created_at=None, updated_at=None, owner=None, owner_type=None, org_id=None, links=None, name=None, description=None, external_id=None, project_id=None, external_zone_id=None, external_region_id=None, cloud_account_ids=None, deployment_id=None, provisioning_status=None, tags=None, custom_properties=None, address=None, type=None, logging_level=None, routes=None):  # noqa: E501
        """LoadBalancer - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._created_at = None
        self._updated_at = None
        self._owner = None
        self._owner_type = None
        self._org_id = None
        self._links = None
        self._name = None
        self._description = None
        self._external_id = None
        self._project_id = None
        self._external_zone_id = None
        self._external_region_id = None
        self._cloud_account_ids = None
        self._deployment_id = None
        self._provisioning_status = None
        self._tags = None
        self._custom_properties = None
        self._address = None
        self._type = None
        self._logging_level = None
        self._routes = None
        self.discriminator = None
        self.id = id
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if owner is not None:
            self.owner = owner
        if owner_type is not None:
            self.owner_type = owner_type
        if org_id is not None:
            self.org_id = org_id
        self.links = links
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if external_id is not None:
            self.external_id = external_id
        if project_id is not None:
            self.project_id = project_id
        if external_zone_id is not None:
            self.external_zone_id = external_zone_id
        self.external_region_id = external_region_id
        if cloud_account_ids is not None:
            self.cloud_account_ids = cloud_account_ids
        if deployment_id is not None:
            self.deployment_id = deployment_id
        if provisioning_status is not None:
            self.provisioning_status = provisioning_status
        if tags is not None:
            self.tags = tags
        if custom_properties is not None:
            self.custom_properties = custom_properties
        if address is not None:
            self.address = address
        if type is not None:
            self.type = type
        if logging_level is not None:
            self.logging_level = logging_level
        self.routes = routes

    @property
    def id(self):
        """Gets the id of this LoadBalancer.  # noqa: E501

        The id of this resource instance  # noqa: E501

        :return: The id of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this LoadBalancer.

        The id of this resource instance  # noqa: E501

        :param id: The id of this LoadBalancer.  # noqa: E501
        :type: str
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_at(self):
        """Gets the created_at of this LoadBalancer.  # noqa: E501

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :return: The created_at of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this LoadBalancer.

        Date when the entity was created. The date is in ISO 8601 and UTC.  # noqa: E501

        :param created_at: The created_at of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this LoadBalancer.  # noqa: E501

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :return: The updated_at of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this LoadBalancer.

        Date when the entity was last updated. The date is ISO 8601 and UTC.  # noqa: E501

        :param updated_at: The updated_at of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._updated_at = updated_at

    @property
    def owner(self):
        """Gets the owner of this LoadBalancer.  # noqa: E501

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :return: The owner of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._owner

    @owner.setter
    def owner(self, owner):
        """Sets the owner of this LoadBalancer.

        Email of the user or display name of the group that owns the entity.  # noqa: E501

        :param owner: The owner of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._owner = owner

    @property
    def owner_type(self):
        """Gets the owner_type of this LoadBalancer.  # noqa: E501

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :return: The owner_type of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._owner_type

    @owner_type.setter
    def owner_type(self, owner_type):
        """Sets the owner_type of this LoadBalancer.

        Type of a owner(user/ad_group) that owns the entity.  # noqa: E501

        :param owner_type: The owner_type of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._owner_type = owner_type

    @property
    def org_id(self):
        """Gets the org_id of this LoadBalancer.  # noqa: E501

        The id of the organization this entity belongs to.  # noqa: E501

        :return: The org_id of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._org_id

    @org_id.setter
    def org_id(self, org_id):
        """Sets the org_id of this LoadBalancer.

        The id of the organization this entity belongs to.  # noqa: E501

        :param org_id: The org_id of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._org_id = org_id

    @property
    def links(self):
        """Gets the links of this LoadBalancer.  # noqa: E501

        hrefs links  # noqa: E501

        :return: The links of this LoadBalancer.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this LoadBalancer.

        hrefs links  # noqa: E501

        :param links: The links of this LoadBalancer.  # noqa: E501
        :type: object
        """
        if links is None:
            raise ValueError("Invalid value for `links`, must not be `None`")  # noqa: E501

        self._links = links

    @property
    def name(self):
        """Gets the name of this LoadBalancer.  # noqa: E501

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :return: The name of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this LoadBalancer.

        A human-friendly name used as an identifier in APIs that support this option.  # noqa: E501

        :param name: The name of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this LoadBalancer.  # noqa: E501

        A human-friendly description.  # noqa: E501

        :return: The description of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this LoadBalancer.

        A human-friendly description.  # noqa: E501

        :param description: The description of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def external_id(self):
        """Gets the external_id of this LoadBalancer.  # noqa: E501

        External entity Id on the provider side.  # noqa: E501

        :return: The external_id of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._external_id

    @external_id.setter
    def external_id(self, external_id):
        """Sets the external_id of this LoadBalancer.

        External entity Id on the provider side.  # noqa: E501

        :param external_id: The external_id of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._external_id = external_id

    @property
    def project_id(self):
        """Gets the project_id of this LoadBalancer.  # noqa: E501

        The id of the project this resource belongs to.  # noqa: E501

        :return: The project_id of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._project_id

    @project_id.setter
    def project_id(self, project_id):
        """Sets the project_id of this LoadBalancer.

        The id of the project this resource belongs to.  # noqa: E501

        :param project_id: The project_id of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._project_id = project_id

    @property
    def external_zone_id(self):
        """Gets the external_zone_id of this LoadBalancer.  # noqa: E501

        The external zoneId of the resource.  # noqa: E501

        :return: The external_zone_id of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._external_zone_id

    @external_zone_id.setter
    def external_zone_id(self, external_zone_id):
        """Sets the external_zone_id of this LoadBalancer.

        The external zoneId of the resource.  # noqa: E501

        :param external_zone_id: The external_zone_id of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._external_zone_id = external_zone_id

    @property
    def external_region_id(self):
        """Gets the external_region_id of this LoadBalancer.  # noqa: E501

        The external regionId of the resource.  # noqa: E501

        :return: The external_region_id of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._external_region_id

    @external_region_id.setter
    def external_region_id(self, external_region_id):
        """Sets the external_region_id of this LoadBalancer.

        The external regionId of the resource.  # noqa: E501

        :param external_region_id: The external_region_id of this LoadBalancer.  # noqa: E501
        :type: str
        """
        if external_region_id is None:
            raise ValueError("Invalid value for `external_region_id`, must not be `None`")  # noqa: E501

        self._external_region_id = external_region_id

    @property
    def cloud_account_ids(self):
        """Gets the cloud_account_ids of this LoadBalancer.  # noqa: E501

        Set of ids of the cloud accounts this resource belongs to.  # noqa: E501

        :return: The cloud_account_ids of this LoadBalancer.  # noqa: E501
        :rtype: list[str]
        """
        return self._cloud_account_ids

    @cloud_account_ids.setter
    def cloud_account_ids(self, cloud_account_ids):
        """Sets the cloud_account_ids of this LoadBalancer.

        Set of ids of the cloud accounts this resource belongs to.  # noqa: E501

        :param cloud_account_ids: The cloud_account_ids of this LoadBalancer.  # noqa: E501
        :type: list[str]
        """

        self._cloud_account_ids = cloud_account_ids

    @property
    def deployment_id(self):
        """Gets the deployment_id of this LoadBalancer.  # noqa: E501

        Deployment id that is associated with this resource.  # noqa: E501

        :return: The deployment_id of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._deployment_id

    @deployment_id.setter
    def deployment_id(self, deployment_id):
        """Sets the deployment_id of this LoadBalancer.

        Deployment id that is associated with this resource.  # noqa: E501

        :param deployment_id: The deployment_id of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._deployment_id = deployment_id

    @property
    def provisioning_status(self):
        """Gets the provisioning_status of this LoadBalancer.  # noqa: E501

        The provisioning status of the resource. One of three provisioning statuses. `PROVISIONING`: The resource is being provisioned. `READY`: The resource is already provisioned. `SUSPEND`: The resource is being destroyed.   # noqa: E501

        :return: The provisioning_status of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._provisioning_status

    @provisioning_status.setter
    def provisioning_status(self, provisioning_status):
        """Sets the provisioning_status of this LoadBalancer.

        The provisioning status of the resource. One of three provisioning statuses. `PROVISIONING`: The resource is being provisioned. `READY`: The resource is already provisioned. `SUSPEND`: The resource is being destroyed.   # noqa: E501

        :param provisioning_status: The provisioning_status of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._provisioning_status = provisioning_status

    @property
    def tags(self):
        """Gets the tags of this LoadBalancer.  # noqa: E501

        A set of tag keys and optional values that were set on this resource.  # noqa: E501

        :return: The tags of this LoadBalancer.  # noqa: E501
        :rtype: list[IaasapistorageprofilesidTags]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this LoadBalancer.

        A set of tag keys and optional values that were set on this resource.  # noqa: E501

        :param tags: The tags of this LoadBalancer.  # noqa: E501
        :type: list[IaasapistorageprofilesidTags]
        """

        self._tags = tags

    @property
    def custom_properties(self):
        """Gets the custom_properties of this LoadBalancer.  # noqa: E501

        Additional properties that may be used to extend the base resource.  # noqa: E501

        :return: The custom_properties of this LoadBalancer.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._custom_properties

    @custom_properties.setter
    def custom_properties(self, custom_properties):
        """Sets the custom_properties of this LoadBalancer.

        Additional properties that may be used to extend the base resource.  # noqa: E501

        :param custom_properties: The custom_properties of this LoadBalancer.  # noqa: E501
        :type: dict(str, str)
        """

        self._custom_properties = custom_properties

    @property
    def address(self):
        """Gets the address of this LoadBalancer.  # noqa: E501

        Primary address allocated or in use by this load balancer. The address could be an in the form of a publicly resolvable DNS name or an IP address.   # noqa: E501

        :return: The address of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._address

    @address.setter
    def address(self, address):
        """Sets the address of this LoadBalancer.

        Primary address allocated or in use by this load balancer. The address could be an in the form of a publicly resolvable DNS name or an IP address.   # noqa: E501

        :param address: The address of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._address = address

    @property
    def type(self):
        """Gets the type of this LoadBalancer.  # noqa: E501

        Define the type/variant of load balancer numbers e.g.for NSX the number virtual servers and pool members load balancer can host  # noqa: E501

        :return: The type of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this LoadBalancer.

        Define the type/variant of load balancer numbers e.g.for NSX the number virtual servers and pool members load balancer can host  # noqa: E501

        :param type: The type of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def logging_level(self):
        """Gets the logging_level of this LoadBalancer.  # noqa: E501

        Defines logging level for collecting load balancer traffic logs.  # noqa: E501

        :return: The logging_level of this LoadBalancer.  # noqa: E501
        :rtype: str
        """
        return self._logging_level

    @logging_level.setter
    def logging_level(self, logging_level):
        """Sets the logging_level of this LoadBalancer.

        Defines logging level for collecting load balancer traffic logs.  # noqa: E501

        :param logging_level: The logging_level of this LoadBalancer.  # noqa: E501
        :type: str
        """

        self._logging_level = logging_level

    @property
    def routes(self):
        """Gets the routes of this LoadBalancer.  # noqa: E501

        The load balancer route configuration regarding ports and protocols.  # noqa: E501

        :return: The routes of this LoadBalancer.  # noqa: E501
        :rtype: list[IaasapiloadbalancersidoperationsscaleRoutes]
        """
        return self._routes

    @routes.setter
    def routes(self, routes):
        """Sets the routes of this LoadBalancer.

        The load balancer route configuration regarding ports and protocols.  # noqa: E501

        :param routes: The routes of this LoadBalancer.  # noqa: E501
        :type: list[IaasapiloadbalancersidoperationsscaleRoutes]
        """
        if routes is None:
            raise ValueError("Invalid value for `routes`, must not be `None`")  # noqa: E501

        self._routes = routes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(LoadBalancer, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, LoadBalancer):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
